<?php

	/**
	 * Central phpPgAdmin configuration.  As a user you may modify the
	 * settings here for your particular configuration.
	 *
	 * $Id: config.inc.php-dist,v 1.26 2003/09/10 07:13:18 chriskl Exp $
	 */

	// An example server.  Create as many of these as you wish,
	// indexed from zero upwards.
	$conf['servers'][0]['desc'] = 'PostgreSQL'; // Display name for server
	$conf['servers'][0]['host'] = '';  // Hostname or IP address for server.
                                      // Null or '' indicates UNIX domain
                                      // socket.
	$conf['servers'][0]['port'] = 5432;         // Database port on server
	$conf['servers'][0]['defaultdb'] = 'template1';  // Default database to connect to.
                                                    // Only change this if your administrator
                                                    // has disabled connections to template1.

	// Example for a second server
	//$conf['servers'][1]['desc'] = 'Dev Server';
	//$conf['servers'][1]['host'] = '192.168.0.1';
	//$conf['servers'][1]['port'] = 5432;
	//$conf['servers'][1]['defaultdb'] = 'template1';

	// Default language setting.  eg 'english', 'polish', etc.
	$conf['default_lang'] = 'english';
	
	// Only show owned databases?
	// Note: This will simply hide other databases in the list - this does not
	// in any way prevent your users from seeing other database by other means.
	// (eg. Run 'SELECT * FROM pg_database' in the SQL area.)
	$conf['owned_only'] = false;

	// Display "system" objects?
	$conf['show_system'] = false;

	// Display reports feature?
	$conf['show_reports'] = true;

	// Only show owned reports?
	// Note: This does not prevent people from accessing other reports by other
	// means.
	$conf['owned_reports_only'] = false;

	// Minimum length users can set their password to.
	$conf['min_password_length'] = 1;

	// Width of the left frame in pixels (object browser)
	$conf['left_width'] = 200;
	
	// Which look & feel theme to use
	$conf['theme'] = 'default';
	
	// Show OIDs when browsing tables?
	$conf['show_oids'] = false;
	
	// Max rows to show on a page when browsing record sets
	$conf['max_rows'] = 30;

	// Max chars of each field to display by default in browse mode
	$conf['max_chars'] = 50;

	// Send XHTML headers?  Unless debugging, it's best to leave this off
	$conf['use_xhtml'] = false;

	/*****************************************
	 * Don't modify anything below this line *
	 *****************************************/

	$conf['version'] = 9;

?>
